#include <cstdio>
#include <streambuf>
using namespace std;

extern "C" {
    int write (int fd, const char* buf, int anz);
}

class outbuf : public streambuf {
  protected:
    static const int pufferSize = 10;   // Groesse des Datenpuffers
    char puffer[pufferSize];            // Datenpuffer

  public:
    /* Konstruktor
     *  - Datenpuffer initialisieren
     *  - ein Zeichen kleiner,
     *    damit das pufferSize-te Zeichen overflow() ausloest
     */
    outbuf() {
        setp (puffer, puffer+(pufferSize-1));
    }

    /* Destruktor
     *  - Datenpuffer leeren
     */
    virtual ~outbuf() {
        sync();
    }

  protected:
    /* Zeichen im Puffer abspeichern
     */
    int pufferLeeren () {
        int anz = pptr()-pbase();
        if (write (1, puffer, anz) != anz) {
            return EOF;
        }
        pbump (-anz);    // Schreibzeiger entspr. zuruecksetzen
        return anz;
    }

    /* Puffer voll
     *  - c und alle vorherigen Zeichen ausgeben
     */
    virtual int_type overflow (int_type c) {
        if (c != EOF) {
            // Zeichen noch in den Puffer einfuegen
            *pptr() = c;
            pbump(1);
        }
        if (pufferLeeren() == EOF) {
            return EOF;
        }
        return c;
    }

    /* Daten mit Datentraeger abgleichen
     *  - Puffer explizit leeren
     */
    virtual int sync () {
        if (pufferLeeren() == EOF) {
            // FEHLER
            return -1;
        }
        return 0;
    }
};
