#include <iostream>
#include <valarray>
using namespace std;

/* Valarray ausgeben
 *  - "size" war frueher "length"
 */
template <class T>
void printValarray (const valarray<T>& va)
{
    for (int i=0; i<va.size(); i++) {
        cout << va[i] << ' ';
    }
    cout << endl;
}

int main()
{
    /* zwei Valarrays mit 10 Elementen definieren
     */
    valarray<double> va1(10), va2(10);

    /* dem ersten Valarray die Werte 1.1 bis 9.9 zuweisen
     */
    for (int i=0; i<10; i++) {
        va1[i] = i * 1.1;
    }

    /* allen Elementen im zweiten Valarray -1 zuweisen
     */
    va2 = -1;

    /* beide Valarrays ausgeben
     */
    printValarray (va1);
    printValarray (va2);

    /* Minimum, Maximum und Summe vom ersten Valarray ausgeben
     */
    cout << "min(): " << min(va1) << endl;
    cout << "max(): " << max(va1) << endl;
    cout << "sum(): " << va1.sum() << endl;

    /* Werte vom ersten dem zweiten Valarray zuweisen
     */
    va2 = va1;

    /* alle Elemente im ersten Valarray loeschen
     */
    va1.resize(0);

    /* beide Valarrays wieder ausgeben
     */
    printValarray (va1);
    printValarray (va2);
}
