#include <iostream>
#include <string>
using namespace std;

int main (int argc, char* argv[])
{
    string basisname, endung, tmpname;

    /* fuer jedes Argument aus der Kommandozeile
     */
    for (int i=1; i<argc; i++) {
        // Argument als "dateiname" verarbeiten
        const string dateiname(argv[i]);
        
        /* anhand erstem Punkt in Basis-Name und Endung aufspalten
         */
        string::size_type pos = dateiname.find('.');
        if (pos != string::npos) {
            /* Punkt gefunden
             *  - basisname sind alle Zeichen bis zum Punkt
             *  - endung sind alle Zeichen nach dem Punkt
             */
            basisname = dateiname.substr (0, pos);
            endung = dateiname.substr (pos);
        }
        else {
            // Punkt nicht gefunden
            basisname = dateiname;
            endung = "";
        }

        /* Tmp-Name anhand Basis-Name und Endung zusammenstellen
         */
        if (endung.empty()) {
            tmpname = basisname + ".old";
        }
        else if (endung == ".cc" || endung == ".C") {
            tmpname = basisname + endung + ".old";
        }
        else if (endung == ".cpp" || endung == ".CPP") {
            tmpname = basisname + ".opp";
        }
        else {
            cerr << argv[0] << ": unbekannte Endung \"" << endung
                            << "\" bei \"" << dateiname << '"' << endl;
            continue;
        }

        /* Dateiname und Tmp-Name ausgeben
         */
        cout << "Dateiname: \"" << dateiname
             << "\"\tTmp-Name: \"" << tmpname << '"' << endl;
    }
}
